function [error] = crossvalidation(set,n,learnFunc,classFunc)

nSamples = length(set.labels);
if mod(nSamples,n)~=0
    display(sprintf('Crossvalidation: Number of samples cannot be divided by number of folds. nSamples: %0.0f, nFolds: %0.0f',nSamples,n));
end

foldMask = zeros(nSamples,1);
foldSize = nSamples/n;
for i = 1:n
    foldMask((i-1)*foldSize+1:i*foldSize) = i;
end

errors = zeros(n,1);
for i = 1:n
    trainSamples = set.samples(foldMask~=i,:);
    trainLabels = set.labels(foldMask~=i);
    testSamples = set.samples(foldMask==i,:);
    testLabels = set.labels(foldMask==i);
    
    classifier = learnFunc(trainSamples,trainLabels);
    out = classFunc(classifier,testSamples);
    errors(i) = sum(out~=testLabels)/foldSize;
end

error = mean(errors);