function [train test] = trainTestSplit(data,mi)
%Tato funkce rozdeli mnozinu "data" (coz je struktura s poli "labels" a
%"samples") na trenovaci a testovaci mnozinu. v pomeru mi/(1-mi).
%Rozdeleni je stratifikovane, tedy bude stejny pomer
%positivnich a negativnich labelu v trenovaci i testovaci mnozine.

if mi>1 || mi<0
    display('split: mi should be real number between 0 and 1');
    return
end



numPos = sum(data.labels==1); %pocet positivnich vzorku
numNeg = sum(data.labels==0); %pocet negativnich vzorku
r1 = randperm(numPos); %zamichani positivnich vzorku
r2 = randperm(numNeg); %zamichani negativnich vzorku  
numTrainPos = round(numPos*(1-mi)); %pocet positivnich vzorku v trenovaci mnozine
numTrainNeg = round(numNeg*(1-mi)); %pocet negativnich vzorku v trenovaci mnozine
numTrain = numTrainPos+numTrainNeg; %pocet vzorku v trenovaci mnozine
negInd = find(data.labels==0); %indexy negativnich vzorku
posInd = find(data.labels==1); %indexy positivnich vzorku
trainPosInd = posInd(r1(1:numTrainPos)); %indexy positivnich vzorku pro vyber do trenovaci mnoziny
trainNegInd = negInd(r2(1:numTrainNeg)); %indexy negativnich vzorku pro vyber do trenovaci mnoziny
trainInd = [trainPosInd; trainNegInd]; %indexy vsech vzorku pro vyber do trenovaci mnoziny

%vyber do trenovaci mnoziny
train.samples = [data.samples(trainPosInd,:); data.samples(trainNegInd,:)]; 
train.labels = [data.labels(trainPosInd); data.labels(trainNegInd)];

%zaverecne zamichani trenovaci mnoziny
r = randperm(numTrain);
train.samples = train.samples(r,:);
train.labels = train.labels(r);

%vyber do testovaci mnoziny (zkopiruje celou mnozinu a pak smaze trenovaci vzorky)
test.samples = data.samples;
test.samples(trainInd,:) = [];
test.labels = data.labels;
test.labels(trainInd) = [];

%zaverecne zamichani testovaci mnoziny
r = randperm(length(data.labels)-numTrain);
test.samples = test.samples(r,:);
test.labels = test.labels(r);

    